; ksz.asm: itt-ott-ktszlam dallamocska, pl.csenghz
	list p=12f508
	list r=dec
	#include <p12f508.inc>
	__config  _ExtRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_OFF
	
; Vegyes konstansok
opt	equ	0xc0	;ez kerl az option regiszterbe
imask	equ	8	;port kezdrtk
omask	equ	0xf8	;tris maszk
h1mask	equ	2	;1. hang maszkja
h2mask	equ	4	;2. hang maszkja
h12mask	equ	6	;egyttes maszk 2 hanghoz

; hangok oszti
fisz	equ	38
g	equ	36
a	equ	32
h	equ	22
d	equ	24

; peridusszmok 0,17 s-hoz
u1	equ	38	; fels bjt 17-es oszthoz
l1	equ	116
u2	equ	29
l2	equ	240	; als bjt 22-es oszthoz
umax	equ	255
lmax	equ	255

; Bitkioszts
#define	oon	gpio,0	; tartramkr vezrlse
#define	os1	gpio,1	; 1. hang kimenet
#define	os2	gpio,2	; 2. hang kimenet

; Makrodefincik
mov	macro	dest,sour
	movf	sour,w
	movwf	dest
	endm
	
movl	macro	dest,num
	movlw	num
	movwf	dest
	endm

djnz	macro	file,addr
	decfsz	file,f
	goto	addr
	endm

	CBLOCK 0X0A	; A blokk kezdcme a RAM-ban 0Ah
	h1
	h2
	ha1
	ha2
	cu
	cl
	oc1
	ENDC			; blokk vge

; program
	org	0
	goto	main
	
; a program elugrik, a nulls lap eleje a szubrutinok lesz

ston17
	mov	h1,ha1
ut17
	djnz	h1,pad17
	movlw	h12mask
	xorwf	gpio,f
	mov	h1,ha1
masik7
	goto	$+1
	goto	$+1
	goto	$+1
utem7
	decf	cl,f
	btfsc	status,z
	djnz	cu,ut17
	retlw 0
pad17	
	nop
	goto	masik7	

ston22
	mov	h1,ha1
ut22
	djnz	h1,pad22
	movlw	h12mask
	xorwf	gpio,f
	mov	h1,ha1
masik2
	movl	h2,3
m2
	djnz	h2,m2
	nop	
utem2
	decf	cl,f
	btfsc	status,z
	djnz	cu,ut22
	retlw 0
pad22	
	nop
	goto	masik2	

dton17
	mov	h1,ha1
	mov	h2,ha2
ut17d
	djnz	h1,pad1
	movlw	h1mask
	xorwf	gpio,f
	mov	h1,ha1
masik7d
	djnz	h2,pad2
	movlw	h2mask
	xorwf	gpio,f
	mov	h2,ha2
utem7d
	decf	cl,f
	btfsc	status,z
	djnz	cu,ut17d
	retlw 0
pad1	
	nop
	goto	masik7d
pad2
	nop
	goto	utem7d	

stont
	mov	h1,ha1
	movl	gpio,0xfc
ut
	djnz	h1,pad
	movlw	h12mask
	xorwf	gpio,f
	mov	h1,ha1
masik
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	btfsc	gpio,3
	retlw 0
	goto	ut
pad
	goto	masik

main	
	movlw	opt	; csak a T0CS bitet trljk, a tbbi rdektelen
	option 
	movlw	imask	;
	movwf	gpio
	movlw	omask	; csak a reset bemenet lesz bemenet
	tris	gpio	; itt aktivldik a kimenet (de stt marad)

	bsf	oon		; ez a "tart" kimenet!
	clrf	cl		; vr egy kicsit
;	bsf	os1		; ellentem kimeneetek
lp1
	djnz	cl,lp1
	movl	ha1,d		; paramterez
	movl	ha2,d
	movl	cu,2*u1-1
	movl	cl,2*l1
	call	ston17		; s hv

	movl	ha1,a		; s gy tovbb, amg a
	movl	ha2,a
	movl	cu,u1
	movl	cl,l1
	call	ston17

	movl	ha1,h
	movl	ha2,h
	movl	cu,u2
	movl	cl,l2
	call	ston22

	movl	ha1,a
	movl	ha2,a
	movl	cu,2*u1-1
	movl	cl,2*l1
	call	ston17

	movl	ha1,d
	movl	ha2,fisz
	movl	cu,u1
	movl	cl,l1
	call	dton17

	movl	ha1,d
	movl	ha2,g
	movl	cu,u1
	movl	cl,l1
	call	dton17

	movl	ha1,a
	movl	ha2,fisz
	movl	cu,3*u1-1
	movl	cl,92
	call	dton17		; hangok el nem fogytak.

gomb    btfss	gpio,3
	goto	calib    ; megnzi a tesztbemenetet
	bcf	oon		; megsznteti a tartst
	bcf	os1
	bsf	os2

;	sleep			; a folytats helyett inkbb
				; elalszik, ha kiveszem elle
				; a pontosvesszt.
	movlw	imask
	movwf	gpio
	movl	ha1,1		; ez egy j hossz ultrahang
	movl	ha2,1		; (kell a kutynak, de fleg
	movl	cu,umax		; arra, hogy a hidegt
	movl	cl,lmax		; kondi kisljn, ha a
	call	dton17		; gombot elengedtk)

	clrf	cl		; Szusszan egyet, ha van
lp2
	djnz	cl,lp2		; mg mibl
	nop			; ez az n hibm
	goto	0		; s ha van tpfeszltsge,
				; akkor tstartol
calib	btfsc	status,gpwuf
	goto	gomb		; bresztve mr nem kalibrlhat!
	movl	ha1,a		; paramterez
	call	stont		; hv
	goto	gomb		; visszatr
	end
